Features

  

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to Base Language - Bug #2133: fix precision for decimal, dynamic-exte... Closed 01/21/2014 01/27/2014

History

#1 - 04/13/2014 04:04 PM - Hynek Cihlar

The following are the cases where the variable initialization fails.

Components of an indeterminate unfixed extent variable passed in as an input-output or output function or procedure parameter are initialized to

zero values, but should be unknown.

Components of an extent variable passed in as an output function parameter are initialized to unknown, should be zero.

Integer or decimal variable passed in as an output function parameter is initialized to unknown, should be zero.

Character variable passed in as an output function parameter is initialized to unknown, should be an empty string.

Logical variable passed in as an output function parameter is initialized to unknown, should be false.

Tested on OpenEdge 10.2B.

Discovered during implementation of "fix precision for decimal, dynamic-extent variables", see #2133 notes 22, 27, 29, 31, 34, 35, 36, 42, 44.

#2 - 04/13/2014 04:23 PM - Hynek Cihlar

- Status changed from New to WIP

#3 - 04/13/2014 05:35 PM - Hynek Cihlar

- File hc_upd20140413a.zip added

Attached is the fix resolving the found parameter initialization issues.

Note that the file variable_definitions.rules contained logic of Progress V9.0C. I removed that since I have no access to this version. Of course, I will

test on the previous versions if needed.

#4 - 04/14/2014 01:41 AM - Constantin Asofiei
https://proj.goldencode.com/issues/2133


Hynek Cihlar wrote:

Note that the file variable_definitions.rules contained logic of Progress V9.0C. I removed that since I have no access to this version.

 

Although we don't have access to V9.0C, the code in variable_definitions.rules must be kept and executed conditionally, as 4GL code written only in

v9 depends on it. The 4GL version can be set via this p2j.cfg.xml configuration:

<parameter name="source-code-version" value="10.2B" />

If this is missing, then v9.0c is assumed.    

In TRPL, to check the source code version, there are the isV9 and isV10 variables (for v9.0c and v10.2B cases).

#5 - 04/14/2014 03:15 PM - Hynek Cihlar

The original source suggests that Progress 9.0C version behaves differently in respect to the parameter initialization. Should I then keep the original

behavior for 9.0C and hope for the best that no regression was introduced?

#6 - 04/17/2014 04:05 PM - Hynek Cihlar

- File hc_upd20140417a.zip added

It turns out I was running the P2J conversion without the proper version defined, i.e. with the default 9.0C as Constantin pointed out. After setting the

version to 10.2B, only the following two cases really needed a fix:

Components of an indeterminate unfixed extent variable passed in as an input-output or output function or procedure parameter are initialized to

zero values, but should be unknown.

Components of an extent variable passed in as an output function parameter are initialized to unknown, should be zero.

Attached is the fix for the above two initialization issues, please review. Regression test is in progress.

#7 - 04/18/2014 03:06 AM - Constantin Asofiei

Hynek Cihlar wrote:

Attached is the fix for the above two initialization issues, please review. Regression test is in progress.

 

The changes look good.
#8 - 04/24/2014 10:42 AM - Hynek Cihlar

0417a passed regression testing and was committed to bzr revision 10513.

#9 - 04/24/2014 10:44 AM - Hynek Cihlar

- % Done changed from 0 to 100

- Status changed from WIP to Review

#10 - 04/24/2014 10:56 AM - Greg Shah

- Status changed from Review to Closed

- Target version set to Milestone 11

#11 - 11/16/2016 12:07 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features

Files

hc_upd20140413a.zip 22.7 KB 04/13/2014 Hynek Cihlar

hc_upd20140417a.zip 22.8 KB 04/17/2014 Hynek Cihlar
